/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <stdio.h>
#include <glib/gprintf.h>

#include "move.h"
#include "string.h"

inline void moveToString(const Move move, gchar string[6]){
    gchar square[3];
    string[0] = '\0';
    squareToString(moveGetFrom(move),square);
    strcat(string,square);
    squareToString(moveGetTo(move),square);
    strcat(string,square);
    switch(moveGetType(move)){
        case Promote_Queen:	{ string[4] = 'q'; break; }
        case Promote_Rook:	{ string[4] = 'r'; break; }
        case Promote_Bishop:{ string[4] = 'b'; break; }
        case Promote_Knight:{ string[4] = 'n'; break; }
		case Null_Move:		{ strcpy(string,"null"); break;}
    };
    string[5] = '\0';
}

void movePrint(const Move move){
	gchar string[6];
	moveToString(move,string);
	g_printf("%s ",string);
	fflush(stdout);
}

void movesPrint(const Moves* moves){
	guint i;
	for(i=0; i<moves->size; i++) movePrint(moves->move[i]);
	g_printf("\n");
}

void rootMovesPrint(const RootMoves* moves){
	guint i;
	for(i=0; i<moves->size; i++) movePrint(moves->move[i].move);
	g_printf("\n");
}

