/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 * \file piece.h
 * File contains functionality about pieces.
 */

#ifndef PIECE_H
#define PIECE_H

#include "glib.h"

#ifndef Empty
#define Empty 0
#endif

#define White 	0
#define Black 	1
#define Pawn 	2
#define Knight	4
#define Bishop	6
#define Rook	8
#define Queen	10
#define King	12
#define White_Pawn 		2
#define White_Knight	4
#define White_Bishop	6
#define White_Rook		8
#define White_Queen		10
#define White_King		12
#define Black_Pawn 		3
#define Black_Knight	5
#define Black_Bishop	7
#define Black_Rook		9
#define Black_Queen		11
#define Black_King		13

#define King_Value 0
#define Pawn_Value 90
#define Knight_Value 300
#define Bishop_Value 325
#define Rook_Value 500
#define Queen_Value 975

#define Knight_Phase 1
#define Bishop_Phase 1
#define Rook_Phase   2
#define Queen_Phase  4
#define Total_Phase 24

static const gint pieceValue[14] = {
	0, 0,
	Pawn_Value, 	Pawn_Value,
	Knight_Value, 	Knight_Value,
	Bishop_Value, 	Bishop_Value,
	Rook_Value, 	Rook_Value,
	Queen_Value, 	Queen_Value,
	King_Value, 	King_Value
};

static const gint piecePhase[14] = {
	0, 0,
	0, 0,
	Knight_Phase, Knight_Phase,
	Bishop_Phase, Bishop_Phase,
	Rook_Phase, Rook_Phase,
	Queen_Phase, Queen_Phase,
	0, 0
};

static const gchar pieceToChar[14] = {
	'X','x', 'P','p', 'N','n', 'B','b', 'R','r', 'Q','q', 'K','k'
};

guint charToPiece(const gchar piece);

#endif
